# 运用git flow 来处理一下场景
    - 主分支 master 开发分支 dev 
    - 赤山项目代码是最新的tagv3.0.9
    - 环球项目代码版本是tag3.0.2(与最新版本差距7次迭代,不完全兼容最新版!)
## 预设:
 1. 本周定版,3.0.10,需要开发4个新功能:A,B,C,D;
 2. 同时还有一个新功能E,是下一个版本的功能,但是需要本周同步开发
 3. 对于dev分支,变动时,将自动部署到测试环境
 4. 对于release分支,上传到线上会自动打beta版本
 5. 对于正式发布的版本,会为tag打正式版,并删除beta版本

## case1: 周一时,如何对上述4个新功能进行开发,git flow如何操作?
```
根据4个新功能的需求，功能尽可能的小，每次都新建一个feature分支，feature分支默认从dev分支,也可以强制指定版本分支
```

## case2: 周4下午,当这4个功能都开发完成后,现在要进行封版处理,如何操作?
```
开发完成后，feature分支完成后上传会合并回dev分支，且feature会被删除。通过dev生成的release/3.0.10分支，测试及后续的BUG修复。
```

## case3:  功能E对开始开发时间有要求吗?对合并时间有要求吗?
```
对开发时间有要求，需要这周完成；可在下一周封板前完成合并。
```

## case4: 周5到周6,测试人员对即将发布的新版本3.0.10(beta)进行了测试,发现了新的bug,如何处理?

```
测试人员按照BUG分支出feature做紧急修复，修复完成后会合并到release3.0.10版本中，小问题也可以在release上面修改。非主线bug，列入到下一迭代，本周不处理。
```
## case5: 下周一,上周的3.0.10测试完全通过,也没发现新的问题,需要正式发布,如何操作?

```
当我们测试完全通过，结束release版本时，会把release合并到master，并且在上面打一个版本的tag，为3.0.10，需要填写描述信息，填写tag的功能。同时release分支将合并到dev分支。
```
## case6: 又过了2天,项目里发现一个严重的bug,需要立马修复,如何操作?
```
这时需要使用hotfix版本，hotfix将会从指定的tag出新建一个hotfix分支，指定分支3.0.11.修复BUG 完成botfix分支，之后hotfix分支会自动合并到dev与master。并在master上打上新的tag，tag名称就是hotfix分支名称。
```

## case7: 环球项目,有一特殊需求新功能D需要开发,开发完成后测试并部署到项目中去,该如何操作?
因为环球 项目代码版本是tag3.0.2 与最新的代码差7个迭代。从master上分出一个新的tag3.03，并在此分支上创建release版本，在此版分出feature 开发新功能。开发完成测试之后合并到release版本。